﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WorkflowApplication
{
    public partial class DesignerForm : Form
    {
        public DesignerForm()
        {
            InitializeComponent();
        }

        private void zoomDropDownMenuItem_Click(object sender, EventArgs e)
        {
            if (sender is ToolStripMenuItem)
            {
                ToolStripMenuItem menuItem = (ToolStripMenuItem)sender;

                int zoomFactor = 0;

                bool result = Int32.TryParse(menuItem.Tag.ToString(), out zoomFactor);

                if (result)
                {
                    this.workflowDesignerControl.ProcessZoom(zoomFactor);
                }
            }
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            this.workflowDesignerControl.DeleteSelected();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            this.workflowDesignerControl.Save();
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            try
            {
                this.workflowDesignerControl.LoadExistingWorkflow();
            }
            catch(InvalidCastException ice)
            {
                MessageBox.Show("State machine workflows cann't be opened!" +
                    "\n\n" + ice.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        } 
    }
}