﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Workflow.Runtime;
using StateMachineTracking;

namespace WorkflowApplication
{
    class InstanceHolder
    {
        public InstanceHolder(WorkflowType wfType, Object instance)
        {
            this.wfType = wfType;

            if (wfType == WorkflowType.Sequential)
                sequentialInstance = (WorkflowInstance)instance;
            else
                if (WFType == WorkflowType.Statemachine)
                    stateMachineInstance = (StateMachineInstance)instance;
                else
                    throw new Exception("Unsupported workflow type exception.");
        }

        private static Dictionary<string, InstanceHolder> instanceColection = new Dictionary<string, InstanceHolder>();

        private WorkflowType wfType;

        public WorkflowType WFType
        {
            get { return wfType; }
            set { wfType = value; }
        }


        private WorkflowInstance sequentialInstance = null;
        private StateMachineInstance stateMachineInstance = null;

        public WorkflowInstance WFInstance
        {
            get
            {
                if (WFType == WorkflowType.Sequential)
                    return sequentialInstance;
                else 
                    if (WFType == WorkflowType.Statemachine)
                        return stateMachineInstance.WorkflowInstance;
                    else
                        throw new Exception("Unsupported workflow type exception.");

            }
        }

        public StateMachineInstance SMInstance
        {
            get { return stateMachineInstance; }
        }

        public static void Add(WorkflowType wfType, Object instance)
        {
            InstanceHolder instanceHolder = new InstanceHolder(wfType, instance);
            instanceColection.Add(instanceHolder.WFInstance.InstanceId.ToString(), instanceHolder);
        }

        public static InstanceHolder Get(string instanceID)
        {
            return instanceColection[instanceID];
        }
    }
}
