﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Workflow.Activities;

namespace WorkflowLibrary
{
    //Клас, който дефинира съобщението, предавано между локалната услуга и потока
    [Serializable]
    public class TaskEventArgs : ExternalDataEventArgs
    {
        private string message;

        public TaskEventArgs(Guid instanceId, string message): base(instanceId)
        {
            this.message = message;
        }

        public string Message
        {
            get { return message; }
            set { message = value; }
        }
	
    }
    
    //Интерфейс, който дефинира договора за комуникация 
    //между локалната услуга и потока
    [ExternalDataExchange]
	public interface ITaskService
	{
        event EventHandler<TaskEventArgs> TaskCreated;
        event EventHandler<TaskEventArgs> TaskRunning;
        event EventHandler<TaskEventArgs> TaskQA;
        event EventHandler<TaskEventArgs> TaskTerminated;
        event EventHandler<TaskEventArgs> TaskCompleted;
        event EventHandler<TaskEventArgs> CodeReviewed;

        void SendMessage(string message);
        
    }
}
